use askama::Template;
use axum::{
    debug_handler,
    extract::{Path, State},
    response::{Html, IntoResponse},
};
use phono_models::workspace::Workspace;
use serde::Deserialize;
use uuid::Uuid;

use crate::{
    app::{App, AppDbConn},
    errors::AppError,
    navigator::Navigator,
    settings::Settings,
    user::CurrentUser,
    workspace_nav::WorkspaceNav,
    workspace_pooler::{RoleAssignment, WorkspacePooler},
};

#[derive(Debug, Deserialize)]
pub(super) struct PathParams {
    workspace_id: Uuid,
}

/// HTTP GET handler for a top-level workspace navigation page. At the moment,
/// this is pretty spare---essentially the workspace navigation sidebar blown
/// up to the size of a full page.
#[debug_handler(state = App)]
pub(super) async fn get(
    State(settings): State<Settings>,
    CurrentUser(user): CurrentUser,
    AppDbConn(mut app_db): AppDbConn,
    Path(PathParams { workspace_id }): Path<PathParams>,
    navigator: Navigator,
    State(mut pooler): State<WorkspacePooler>,
) -> Result<impl IntoResponse, AppError> {
    // FIXME: Check workspace authorization.

    let workspace = Workspace::with_id(workspace_id)
        .fetch_one(&mut app_db)
        .await?;

    let mut workspace_client = pooler
        .acquire_for(workspace_id, RoleAssignment::User(user.id))
        .await?;

    #[derive(Template)]
    #[template(path = "workspaces_single/nav.html")]
    struct ResponseTemplate {
        settings: Settings,
        workspace: Workspace,
        workspace_nav: WorkspaceNav,
    }

    Ok(Html(
        ResponseTemplate {
            workspace_nav: WorkspaceNav::builder()
                .navigator(navigator)
                .workspace(workspace.clone())
                .populate_rels(&mut app_db, &mut workspace_client)
                .await?
                .build()?,
            settings,
            workspace,
        }
        .render()?,
    ))
}
